---
title: '<table>: The Table element'
slug: Web/HTML/Element/table
tags:
  - Element
  - HTML
  - HTML tabular data
  - NeedsLiveSample
  - Reference
  - Sorting
  - Tables
  - Web
---
<div>{{HTMLRef}}</div>

<p><span class="seoSummary">The <strong>HTML <code>&lt;table&gt;</code> element</strong> represents tabular data — that is, information presented in a two-dimensional table comprised of rows and columns of cells containing data.</span></p>

<div>{{EmbedInteractiveExample("pages/tabbed/table.html","tabbed-standard")}}</div>

<p class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples </a> and send us a pull request.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row"><a href="/en-US/docs/Web/Guide/HTML/Content_categories">Content categories</a></th>
   <td><a href="/en-US/docs/Web/Guide/HTML/Content_categories#Flow_content">Flow content</a></td>
  </tr>
  <tr>
   <th scope="row">Permitted content</th>
   <td>
    <div class="content-models">
    <div id="table-mdls">In this order:
    <ol>
     <li>an optional {{HTMLElement("caption")}} element,</li>
     <li>zero or more {{HTMLElement("colgroup")}} elements,</li>
     <li>an optional {{HTMLElement("thead")}} element,</li>
     <li>either one of the following:
      <ul>
       <li>zero or more {{HTMLElement("tbody")}} elements</li>
       <li>one or more {{HTMLElement("tr")}} elements</li>
      </ul>
     </li>
     <li>an optional {{HTMLElement("tfoot")}} element</li>
    </ol>
    </div>
    </div>
   </td>
  </tr>
  <tr>
   <th scope="row">Tag omission</th>
   <td>{{no_tag_omission}}</td>
  </tr>
  <tr>
   <th scope="row">Permitted parents</th>
   <td>Any element that accepts flow content</td>
  </tr>
  <tr>
   <th scope="row">Implicit ARIA role</th>
   <td><code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Table_Role">table</a></code></td>
  </tr>
  <tr>
   <th scope="row">Permitted ARIA roles</th>
   <td>Any</td>
  </tr>
  <tr>
   <th scope="row">DOM interface</th>
   <td>{{domxref("HTMLTableElement")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Attributes">Attributes</h2>

<p>This element includes the <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a>.</p>

<h3 id="Deprecated_attributes">Deprecated attributes</h3>

<dl>
 <dt>{{htmlattrdef("align")}} {{Deprecated_inline}}</dt>
 <dd>
 <p>This enumerated attribute indicates how the table must be aligned inside the containing document. It may have the following values:</p>

 <ul>
  <li><code>left</code>: the table is displayed on the left side of the document;</li>
  <li><code>center</code>: the table is displayed in the center of the document;</li>
  <li><code>right</code>: the table is displayed on the right side of the document.</li>
 </ul>

 <p>Set {{cssxref("margin-left")}} and {{cssxref("margin-right")}} to <code>auto</code> or {{cssxref("margin")}} to <code>0 auto</code> to achieve an effect that is similar to the align attribute.</p>
 </dd>
 <dt>{{htmlattrdef("bgcolor")}} {{Deprecated_inline}}</dt>
 <dd>
 <p>The background color of the table. It is a <a href="/en-US/docs/Web/CSS/color_value#RGB_colors">6-digit hexadecimal RGB code</a>, prefixed by a '<code>#</code>'. One of the predefined <a href="/en-US/docs/Web/CSS/color_value#Color_keywords">color kewords</a> can also be used.</p>

 <p>To achieve a similar effect, use the CSS {{cssxref("background-color")}} property.</p>
 </dd>
 <dt>{{htmlattrdef("border")}} {{Deprecated_inline}}</dt>
 <dd>
 <p>This integer attribute defines, in pixels, the size of the frame surrounding the table. If set to 0, the {{htmlattrxref("frame", "table")}} attribute is set to void.</p>

 <p>To achieve a similar effect, use the CSS {{cssxref("border")}} shorthand property.</p>
 </dd>
 <dt>{{htmlattrdef("cellpadding")}} {{Deprecated_inline}}</dt>
 <dd>
 <p>This attribute defines the space between the content of a cell and its border, displayed or not. If the cellpadding's length is defined in pixels, this pixel-sized space will be applied to all four sides of the cell's content. If the length is defined using a percentage value, the content will be centered and the total vertical space (top and bottom) will represent this value. The same is true for the total horizontal space (left and right).</p>

 <p>To achieve a similar effect, apply the {{cssxref("border-collapse")}} property to the <code>&lt;table&gt;</code> element, with its value set to collapse, and the {{cssxref("padding")}} property to the {{HTMLElement("td")}} elements.</p>
 </dd>
 <dt>{{htmlattrdef("cellspacing")}} {{Deprecated_inline}}</dt>
 <dd>
 <p>This attribute defines the size of the space between two cells in a percentage value or pixels. The attribute is applied both horizontally and vertically, to the space between the top of the table and the cells of the first row, the left of the table and the first column, the right of the table and the last column and the bottom of the table and the last row.</p>

 <p>To achieve a similar effect, apply the {{cssxref("border-spacing")}} property to the <code>&lt;table&gt;</code> element. <code>border-spacing</code> does not have any effect if {{cssxref("border-collapse")}} is set to collapse.</p>
 </dd>
 <dt>{{htmlattrdef("frame")}} {{Deprecated_inline}}</dt>
 <dd>
 <p>This enumerated attribute defines which side of the frame surrounding the table must be displayed.</p>

 <p>To achieve a similar effect, use the {{cssxref("border-style")}} and {{cssxref("border-width")}} properties.</p>
 </dd>
 <dt>{{htmlattrdef("rules")}} {{Deprecated_inline}}</dt>
 <dd>
 <p>This enumerated attribute defines where rules, i.e. lines, should appear in a table. It can have the following values:</p>

 <ul>
  <li><code>none</code>, which indicates that no rules will be displayed; it is the default value;</li>
  <li><code>groups</code>, which will cause the rules to be displayed between row groups (defined by the {{HTMLElement("thead")}}, {{HTMLElement("tbody")}} and {{HTMLElement("tfoot")}} elements) and between column groups (defined by the {{HTMLElement("col")}} and {{HTMLElement("colgroup")}} elements) only;</li>
  <li><code>rows</code>, which will cause the rules to be displayed between rows;</li>
  <li><code>columns</code>, which will cause the rules to be displayed between columns;</li>
  <li><code>all</code>, which will cause the rules to be displayed between rows and columns.</li>
 </ul>

 <p>To achieve a similar effect, apply the {{cssxref("border")}} property to the appropriate {{HTMLElement("thead")}}, {{HTMLElement("tbody")}}, {{HTMLElement("tfoot")}}, {{HTMLElement("col")}}, or {{HTMLElement("colgroup")}} elements.</p>
 </dd>
 <dt>{{htmlattrdef("summary")}} {{Deprecated_inline}}</dt>
 <dd>This attribute defines an alternative text that summarizes the content of the table. Use the {{htmlelement("caption")}} element instead.</dd>
 <dt>{{htmlattrdef("width")}} {{Deprecated_inline}}</dt>
 <dd>
 <p>This attribute defines the width of the table. Use the CSS {{cssxref("width")}} property instead.</p>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Simple_table">Simple table</h3>

<pre class="brush: html notranslate">&lt;table&gt;
  &lt;tr&gt;
    &lt;td&gt;John&lt;/td&gt;
    &lt;td&gt;Doe&lt;/td&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;Jane&lt;/td&gt;
    &lt;td&gt;Doe&lt;/td&gt;
  &lt;/tr&gt;
&lt;/table&gt;
</pre>

<p>{{EmbedLiveSample('Simple_table', '100%', '100')}}</p>

<h3 id="Further_simple_examples">Further simple examples</h3>

<pre class="brush: html notranslate">&lt;p&gt;Simple table with header&lt;/p&gt;
&lt;table&gt;
  &lt;tr&gt;
    &lt;th&gt;First name&lt;/th&gt;
    &lt;th&gt;Last name&lt;/th&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;John&lt;/td&gt;
    &lt;td&gt;Doe&lt;/td&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;Jane&lt;/td&gt;
    &lt;td&gt;Doe&lt;/td&gt;
  &lt;/tr&gt;
&lt;/table&gt;

&lt;p&gt;Table with thead, tfoot, and tbody&lt;/p&gt;
&lt;table&gt;
  &lt;thead&gt;
    &lt;tr&gt;
      &lt;th&gt;Header content 1&lt;/th&gt;
      &lt;th&gt;Header content 2&lt;/th&gt;
    &lt;/tr&gt;
  &lt;/thead&gt;
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;td&gt;Body content 1&lt;/td&gt;
      &lt;td&gt;Body content 2&lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
  &lt;tfoot&gt;
    &lt;tr&gt;
      &lt;td&gt;Footer content 1&lt;/td&gt;
      &lt;td&gt;Footer content 2&lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tfoot&gt;
&lt;/table&gt;

&lt;p&gt;Table with colgroup&lt;/p&gt;
&lt;table&gt;
  &lt;colgroup span="4"&gt;&lt;/colgroup&gt;
  &lt;tr&gt;
    &lt;th&gt;Countries&lt;/th&gt;
    &lt;th&gt;Capitals&lt;/th&gt;
    &lt;th&gt;Population&lt;/th&gt;
    &lt;th&gt;Language&lt;/th&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;USA&lt;/td&gt;
    &lt;td&gt;Washington, D.C.&lt;/td&gt;
    &lt;td&gt;309 million&lt;/td&gt;
    &lt;td&gt;English&lt;/td&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;Sweden&lt;/td&gt;
    &lt;td&gt;Stockholm&lt;/td&gt;
    &lt;td&gt;9 million&lt;/td&gt;
    &lt;td&gt;Swedish&lt;/td&gt;
  &lt;/tr&gt;
&lt;/table&gt;

&lt;p&gt;Table with colgroup and col&lt;/p&gt;
&lt;table&gt;
  &lt;colgroup&gt;
    &lt;col style="background-color: #0f0"&gt;
    &lt;col span="2"&gt;
  &lt;/colgroup&gt;
  &lt;tr&gt;
    &lt;th&gt;Lime&lt;/th&gt;
    &lt;th&gt;Lemon&lt;/th&gt;
    &lt;th&gt;Orange&lt;/th&gt;
  &lt;/tr&gt;
  &lt;tr&gt;
    &lt;td&gt;Green&lt;/td&gt;
    &lt;td&gt;Yellow&lt;/td&gt;
    &lt;td&gt;Orange&lt;/td&gt;
  &lt;/tr&gt;
&lt;/table&gt;

&lt;p&gt;Simple table with caption&lt;/p&gt;
&lt;table&gt;
  &lt;caption&gt;Awesome caption&lt;/caption&gt;
  &lt;tr&gt;
    &lt;td&gt;Awesome data&lt;/td&gt;
  &lt;/tr&gt;
&lt;/table&gt;
</pre>

<div class="hidden">
<pre class="brush: css notranslate">table
{
border-collapse: collapse;
border-spacing: 0px;
}
table, th, td
{
padding: 5px;
border: 1px solid black;
}</pre>
</div>

<p>{{EmbedLiveSample('Further_simple_examples', '100%', '700')}}</p>

<div class="hidden">
<h3 id="Table_sorting">Table sorting</h3>

<h4 id="Sorting_table_rows">Sorting table rows</h4>

<p>There are no native methods for sorting the rows (<code><a href="/en-US/docs/Web/HTML/Element/tr">&lt;tr&gt;</a></code> elements) of an HTML table. But using <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/slice">Array.prototype.slice()</a></code>, <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/sort">Array.prototype.sort()</a></code>, <code><a href="/en-US/docs/Web/API/Node/removeChild">Node.removeChild()</a></code>, and <code><a href="/en-US/docs/Web/API/Node/appendChild">Node.appendChild()</a></code>, you can implement your own <code>sort()</code> function to sort an <code><a href="/en-US/docs/Web/API/HTMLCollection">HTMLCollection</a></code> of <code>&lt;tr&gt;</code> elements.</p>

<p>In the below example, you can see such an example. We are attaching it to the &lt;tbody&gt; element so that it sorts the table cells in order of increasing value, and updates the display to suit.</p>

<h5 id="HTML">HTML</h5>

<pre class="brush: html notranslate">&lt;table&gt;
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;td&gt;3&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;td&gt;2&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;td&gt;1&lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
&lt;/table&gt;
</pre>

<h5 id="JavaScript">JavaScript</h5>

<pre class="brush: js notranslate">HTMLTableSectionElement.prototype.sort = function(cb){
  Array
    .prototype
    .slice
    .call(this.rows)
    .sort(cb)
    .forEach((e,i,a)=&gt;{
      this.appendChild(this.removeChild(e));
    },this);
}

document.querySelector('table').tBodies[0].sort(function(a, b){
    return a.textContent.localeCompare(b.textContent);
});
</pre>

<h5 id="Result">Result</h5>

<p>{{EmbedLiveSample('Sorting_table_rows', '100%', '100')}}</p>

<h4 id="Sorting_rows_with_a_click_on_the_th_element">Sorting rows with a click on the th element</h4>

<p>The following example adds an event handler to every <code>&lt;th&gt;</code> element of every <code>&lt;table&gt;</code> in the <code>document</code>; it sorts all the <code>&lt;tbody&gt;</code>'s rows, basing the sorting on the <code>td</code> cells contained in the rows.</p>

<div class="notecard note">
<p><strong>Note</strong>: This solution assumes that the <code>&lt;td&gt;</code> elements are populated by raw text with no descendant elements.</p>
</div>

<h5 id="HTML_2">HTML</h5>

<pre class="brush: html notranslate">&lt;table&gt;
  &lt;thead&gt;
    &lt;tr&gt;
      &lt;th&gt;Numbers&lt;/th&gt;
      &lt;th&gt;Letters&lt;/th&gt;
    &lt;/tr&gt;
  &lt;/thead&gt;
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;td&gt;3&lt;/td&gt;
      &lt;td&gt;A&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;td&gt;2&lt;/td&gt;
      &lt;td&gt;B&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;td&gt;1&lt;/td&gt;
      &lt;td&gt;C&lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
&lt;/table&gt;</pre>

<h5 id="JavaScript_2">JavaScript</h5>

<pre class="brush: js notranslate">for (let table of document.querySelectorAll('table')) {
  for (let th of table.tHead.rows[0].cells) {
    th.onclick = function(){
      const tBody = table.tBodies[0];
      const rows = tBody.rows;
      for (let tr of rows) {
        Array.prototype.slice.call(rows)
          .sort(function(tr1, tr2){
            const cellIndex = th.cellIndex;
            return tr1.cells[cellIndex].textContent.localeCompare(tr2.cells[cellIndex].textContent);
          })
          .forEach(function(tr){
            this.appendChild(this.removeChild(tr));
          }, tBody);
      }
    }
  }
}</pre>

<h5 id="Result_2">Result</h5>

<p>{{EmbedLiveSample('Sorting_rows_with_a_click_on_the_th_element', '100%', '100')}}</p>

<h3 id="Displaying_large_tables_in_small_spaces">Displaying large tables in small spaces</h3>

<p>A common issue with tables on the web is that they don’t natively work very well on small screens when the amount of content is large, and the way to make them scrollable isn’t obvious, especially when the markup may come from a CDN and cannot be modified to have a wrapper.</p>

<p>This example provides one way to display tables in small spaces. We've hidden the HTML content as it is very large, and there is nothing remarkable about it. The CSS is more useful to inspect in this example.</p>

<div class="hidden">
<pre class="brush: html notranslate">&lt;table&gt;
  &lt;thead&gt;
    &lt;tr&gt;
      &lt;th&gt;1&lt;sup&gt;3&lt;/sup&gt; equals:
      &lt;th&gt;2&lt;sup&gt;3&lt;/sup&gt; equals:
      &lt;th&gt;3&lt;sup&gt;3&lt;/sup&gt; equals:
      &lt;th&gt;4&lt;sup&gt;3&lt;/sup&gt; equals:
      &lt;th&gt;5&lt;sup&gt;3&lt;/sup&gt; equals:
      &lt;th&gt;6&lt;sup&gt;3&lt;/sup&gt; equals:
      &lt;th&gt;7&lt;sup&gt;3&lt;/sup&gt; equals:
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;td&gt;row 1: 1
      &lt;td&gt;row 1: 8
      &lt;td&gt;row 1: 27
      &lt;td&gt;row 1: 64
      &lt;td&gt;row 1: 125
      &lt;td&gt;row 1: 216
      &lt;td&gt;row 1: 343
    &lt;tr&gt;
      &lt;td&gt;row 2: 1
      &lt;td&gt;row 2: 8
      &lt;td&gt;row 2: 27
      &lt;td&gt;row 2: 64
      &lt;td&gt;row 2: 125
      &lt;td&gt;row 2: 216
      &lt;td&gt;row 2: 343
    &lt;tr&gt;
      &lt;td&gt;row 3: 1
      &lt;td&gt;row 3: 8
      &lt;td&gt;row 3: 27
      &lt;td&gt;row 3: 64
      &lt;td&gt;row 3: 125
      &lt;td&gt;row 3: 216
      &lt;td&gt;row 3: 343
    &lt;tr&gt;
      &lt;td&gt;row 4: 1
      &lt;td&gt;row 4: 8
      &lt;td&gt;row 4: 27
      &lt;td&gt;row 4: 64
      &lt;td&gt;row 4: 125
      &lt;td&gt;row 4: 216
      &lt;td&gt;row 4: 343
    &lt;tr&gt;
      &lt;td&gt;row 5: 1
      &lt;td&gt;row 5: 8
      &lt;td&gt;row 5: 27
      &lt;td&gt;row 5: 64
      &lt;td&gt;row 5: 125
      &lt;td&gt;row 5: 216
      &lt;td&gt;row 5: 343
    &lt;tr&gt;
      &lt;td&gt;row 6: 1
      &lt;td&gt;row 6: 8
      &lt;td&gt;row 6: 27
      &lt;td&gt;row 6: 64
      &lt;td&gt;row 6: 125
      &lt;td&gt;row 6: 216
      &lt;td&gt;row 6: 343
    &lt;tr&gt;
      &lt;td&gt;row 7: 1
      &lt;td&gt;row 7: 8
      &lt;td&gt;row 7: 27
      &lt;td&gt;row 7: 64
      &lt;td&gt;row 7: 125
      &lt;td&gt;row 7: 216
      &lt;td&gt;row 7: 343
    &lt;tr&gt;
      &lt;td&gt;row 8: 1
      &lt;td&gt;row 8: 8
      &lt;td&gt;row 8: 27
      &lt;td&gt;row 8: 64
      &lt;td&gt;row 8: 125
      &lt;td&gt;row 8: 216
      &lt;td&gt;row 8: 343
    &lt;tr&gt;
      &lt;td&gt;row 9: 1
      &lt;td&gt;row 9: 8
      &lt;td&gt;row 9: 27
      &lt;td&gt;row 9: 64
      &lt;td&gt;row 9: 125
      &lt;td&gt;row 9: 216
      &lt;td&gt;row 9: 343
    &lt;tr&gt;
      &lt;td&gt;row 10: 1
      &lt;td&gt;row 10: 8
      &lt;td&gt;row 10: 27
      &lt;td&gt;row 10: 64
      &lt;td&gt;row 10: 125
      &lt;td&gt;row 10: 216
      &lt;td&gt;row 10: 343
    &lt;tr&gt;
      &lt;td&gt;row 11: 1
      &lt;td&gt;row 11: 8
      &lt;td&gt;row 11: 27
      &lt;td&gt;row 11: 64
      &lt;td&gt;row 11: 125
      &lt;td&gt;row 11: 216
      &lt;td&gt;row 11: 343
    &lt;tr&gt;
      &lt;td&gt;row 12: 1
      &lt;td&gt;row 12: 8
      &lt;td&gt;row 12: 27
      &lt;td&gt;row 12: 64
      &lt;td&gt;row 12: 125
      &lt;td&gt;row 12: 216
      &lt;td&gt;row 12: 343
    &lt;tr&gt;
      &lt;td&gt;row 13: 1
      &lt;td&gt;row 13: 8
      &lt;td&gt;row 13: 27
      &lt;td&gt;row 13: 64
      &lt;td&gt;row 13: 125
      &lt;td&gt;row 13: 216
      &lt;td&gt;row 13: 343
    &lt;tr&gt;
      &lt;td&gt;row 14: 1
      &lt;td&gt;row 14: 8
      &lt;td&gt;row 14: 27
      &lt;td&gt;row 14: 64
      &lt;td&gt;row 14: 125
      &lt;td&gt;row 14: 216
      &lt;td&gt;row 14: 343
    &lt;tr&gt;
      &lt;td&gt;row 15: 1
      &lt;td&gt;row 15: 8
      &lt;td&gt;row 15: 27
      &lt;td&gt;row 15: 64
      &lt;td&gt;row 15: 125
      &lt;td&gt;row 15: 216
      &lt;td&gt;row 15: 343
    &lt;tr&gt;
      &lt;td&gt;row 16: 1
      &lt;td&gt;row 16: 8
      &lt;td&gt;row 16: 27
      &lt;td&gt;row 16: 64
      &lt;td&gt;row 16: 125
      &lt;td&gt;row 16: 216
      &lt;td&gt;row 16: 343
    &lt;tr&gt;
      &lt;td&gt;row 17: 1
      &lt;td&gt;row 17: 8
      &lt;td&gt;row 17: 27
      &lt;td&gt;row 17: 64
      &lt;td&gt;row 17: 125
      &lt;td&gt;row 17: 216
      &lt;td&gt;row 17: 343
    &lt;tr&gt;
      &lt;td&gt;row 18: 1
      &lt;td&gt;row 18: 8
      &lt;td&gt;row 18: 27
      &lt;td&gt;row 18: 64
      &lt;td&gt;row 18: 125
      &lt;td&gt;row 18: 216
      &lt;td&gt;row 18: 343
    &lt;tr&gt;
      &lt;td&gt;row 19: 1
      &lt;td&gt;row 19: 8
      &lt;td&gt;row 19: 27
      &lt;td&gt;row 19: 64
      &lt;td&gt;row 19: 125
      &lt;td&gt;row 19: 216
      &lt;td&gt;row 19: 343
    &lt;tr&gt;
      &lt;td&gt;row 20: 1
      &lt;td&gt;row 20: 8
      &lt;td&gt;row 20: 27
      &lt;td&gt;row 20: 64
      &lt;td&gt;row 20: 125
      &lt;td&gt;row 20: 216
      &lt;td&gt;row 20: 343
&lt;/table&gt;
</pre>
</div>

<p>When looking at these styles you’ll notice that table’s {{cssxref("display")}} property has been set to <code>block</code>. While this allows scrolling, the table loses some of its integrity, and table cells try to become as small as possible. To mitigate this issue we've set {{cssxref("white-space")}} to <code>nowrap</code> on the <code>&lt;tbody&gt;</code>. However, we don’t do this for the <code>&lt;thead&gt;</code> to avoid long titles forcing columns to be wider than they need to be to display the data.</p>

<p>To keep the table headers on the page while scrolling down we've set {{cssxref("position")}} to sticky on the <code>&lt;th&gt;</code> elements. Note that we have <strong>not</strong> set {{cssxref("border-collapse")}}  to <code>collapse</code>, as if we do the header cannot be separated correctly from the rest of the table.</p>

<pre class="brush: css notranslate">table,
th,
td {
    border: 1px solid;
}

table {
    width: 100%;
    max-width: 400px;
    height: 240px;
    margin: 0 auto;
    display: block;
    overflow-x: auto;
    border-spacing: 0;
}

tbody {
    white-space: nowrap;
}

th,
td {
    padding: 5px 10px;
    border-top-width: 0;
    border-left-width: 0;
}

th {
    position: sticky;
    top: 0;
    background: #fff;
    vertical-align: bottom;
}

th:last-child,
td:last-child {
    border-right-width: 0;
}

tr:last-child td {
    border-bottom-width: 0;
}
</pre>

<h4 id="Result_3">Result</h4>

<p>{{EmbedLiveSample('Displaying_large_tables_in_small_spaces', '100%', 240)}}</p>
</div>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<h3 id="Captions">Captions</h3>

<p>By supplying a {{HTMLElement("caption")}} element whose value clearly and concisely describes the table's purpose, it helps the people decide if they need to read the rest of the table content or skip over it.</p>

<p>This helps people navigating with the aid of assistive technology such as a screen reader, people experiencing low vision conditions, and people with cognitive concerns.</p>

<ul>
 <li><a href="/en-US/docs/Learn/HTML/Tables/Advanced#Adding_a_caption_to_your_table_with_&lt;caption&gt;">MDN Adding a caption to your table with &lt;caption&gt;</a></li>
 <li><a href="https://www.w3.org/WAI/tutorials/tables/caption-summary/">Caption &amp; Summary • Tables • W3C WAI Web Accessibility Tutorials</a></li>
</ul>

<h3 id="Scoping_rows_and_columns">Scoping rows and columns</h3>

<p>The {{htmlattrxref("scope", "th")}} attribute on header elements is redundant in simple contexts, because scope is inferred. However, some assistive technologies may fail to draw correct inferences, so specifying header scope may improve user experiences. In complex tables, scope can be specified so as to provide necessary information about the cells related to a header.</p>

<h4 id="Example">Example</h4>

<pre class="brush: html notranslate">&lt;table&gt;
  &lt;caption&gt;Color names and values&lt;/caption&gt;
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;th scope="col"&gt;Name&lt;/th&gt;
      &lt;th scope="col"&gt;HEX&lt;/th&gt;
      &lt;th scope="col"&gt;HSLa&lt;/th&gt;
      &lt;th scope="col"&gt;RGBa&lt;/th&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;th scope="row"&gt;Teal&lt;/th&gt;
      &lt;td&gt;&lt;code&gt;#51F6F6&lt;/code&gt;&lt;/td&gt;
      &lt;td&gt;&lt;code&gt;hsla(180, 90%, 64%, 1)&lt;/code&gt;&lt;/td&gt;
      &lt;td&gt;&lt;code&gt;rgba(81, 246, 246, 1)&lt;/code&gt;&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;th scope="row"&gt;Goldenrod&lt;/th&gt;
      &lt;td&gt;&lt;code&gt;#F6BC57&lt;/code&gt;&lt;/td&gt;
      &lt;td&gt;&lt;code&gt;hsla(38, 90%, 65%, 1)&lt;/code&gt;&lt;/td&gt;
      &lt;td&gt;&lt;code&gt;rgba(246, 188, 87, 1)&lt;/code&gt;&lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
&lt;/table&gt;
</pre>

<p>Providing a declaration of <code>scope="col"</code> on a {{HTMLElement("th")}} element will help describe that the cell is at the top of a column. Providing a declaration of <code>scope="row"</code> on a {{HTMLElement("th")}} element will help describe that the cell is the first in a row.</p>

<ul>
 <li><a href="/en-US/docs/Learn/HTML/Tables/Advanced#Tables_for_visually_impaired_users">MDN Tables for visually impaired users</a></li>
 <li><a href="https://www.w3.org/WAI/tutorials/tables/two-headers/">Tables with two headers • Tables • W3C WAI Web Accessibility Tutorials</a></li>
 <li><a href="https://www.w3.org/WAI/tutorials/tables/irregular/">Tables with irregular headers • Tables • W3C WAI Web Accessibility Tutorials</a></li>
 <li><a href="https://www.w3.org/TR/WCAG20-TECHS/H63.html">H63: Using the scope attribute to associate header cells and data cells in data tables | W3C Techniques for WCAG 2.0</a></li>
</ul>

<h3 id="Complicated_tables">Complicated tables</h3>

<p>Assistive technology such as screen readers may have difficulty parsing tables that are so complex that header cells can’t be associated in a strictly horizontal or vertical way. This is typically indicated by the presence of the {{htmlattrxref("colspan", "td")}} and {{htmlattrxref("rowspan", "td")}} attributes.</p>

<p>Ideally, consider alternate ways to present the table's content, including breaking it apart into a collection of smaller, related tables that don't have to rely on using the <code>colspan</code> and <code>rowspan</code> attributes. In addition to helping people who use assistive technology understand the table's content, this may also benefit people with cognitive concerns who may have difficulty understanding the associations the table layout is describing.</p>

<p>If the table cannot be broken apart, use a combination of the {{htmlattrxref("id")}} and {{htmlattrxref("headers", "td")}} attributes to programmatically associate each table cell with the header(s) the cell is associated with.</p>

<ul>
 <li><a href="/en-US/docs/Learn/HTML/Tables/Advanced#Tables_for_visually_impaired_users">MDN Tables for visually impaired users</a></li>
 <li><a href="https://www.w3.org/WAI/tutorials/tables/multi-level/">Tables with multi-level headers • Tables • W3C WAI Web Accessibility Tutorials</a></li>
 <li><a href="https://www.w3.org/TR/WCAG20-TECHS/H43.html">H43: Using id and headers attributes to associate data cells with header cells in data tables | Techniques for W3C WCAG 2.0</a></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG','tables.html#the-table-element','table element')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C','tabular-data.html#the-table-element','table element')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.table")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>CSS properties that may be especially useful to style the <code>&lt;table&gt;</code> element:

  <ul>
   <li>{{cssxref("width")}} to control the width of the table;</li>
   <li>{{cssxref("border")}}, {{cssxref("border-style")}}, {{cssxref("border-color")}}, {{cssxref("border-width")}}, {{cssxref("border-collapse")}}, {{cssxref("border-spacing")}} to control the aspect of cell borders, rules and frame;</li>
   <li>{{cssxref("margin")}} and {{cssxref("padding")}} to style the individual cell content;</li>
   <li>{{cssxref("text-align")}} and {{cssxref("vertical-align")}} to define the alignment of text and cell content.</li>
  </ul>
 </li>
</ul>
